//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <memory>
#include <winuser.h>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;
std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//     auto_ptr
// -     NULL
template <class T>
ostream& operator<< (ostream& strm, const auto_ptr<T>& p)
{
  //     ?
  if (p.get() == NULL)
  {
    strm << "NULL";  // :   NULL
  }
  else
  {
    strm << *p;      // :  
  }
  return strm;
}

int main(int argc, char* argv[])
{
  const auto_ptr <int> p(new int(42));
  const auto_ptr <int> q(new int(0));
  const auto_ptr <int> r;
  cout << ToRus(" :") << endl;
  cout <<" p: " << p << endl;
  cout <<" q: " << q << endl;
  cout <<" r: " << r << endl;
  *q = *p;
  // :  
  // *r = *p;
  *p = -77;
  cout << ToRus("  :") << endl;
  cout <<" p: " << p << endl;
  cout <<" q: " << q << endl;
  cout <<" r: " << r << endl;
  //  
  // q = p;
  //  
  // r = p;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
